



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python3-深浅copy</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python3-深浅copy</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 22:39:42 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>转载：https://www.cnblogs.com/ctztake/p/8194275.html</h3>
<h3>术语</h3>
<ul><li>变量：是一个系统表的元素，拥有指向对象的连接空间。</li>
<li>对象：被分配的一块内存，存储其所代表的值。</li>
<li>引用：是自动形成的从变量到对象的指针。</li>
<li>注意：类型（int类型，long类型（python3已除去））对于对象，不是变量。</li>
<li>不可变对象：一旦创建就不可修改的对象，包括字符串，元组，数字。</li>
<li>可变对象：可以修改的对象，包括列表，字典。（可通过hash（）来判断对象是否可变）</li></ul>
<p><strong>关于python3深浅拷贝，会以下面三个点来讲述。</strong></p>
<p><strong>先说下copy，这里定义的copy，是指在内存里完全是两块独立的内存空间（既id值不一样），如果两个变量是引用同一个对象的内存地址（id值一样），则不叫copy。</strong></p>
<ol><li><strong>赋值</strong></li>
<li><strong>浅copy</strong></li>
<li><strong>深copy</strong></li></ol>
<h3>数字和字符串</h3>
<p>对于数字和字符串而言，赋值、深浅拷贝毫无意义，因为他们的值永远都会纸箱同一个内存地址。</p>
<div>
<pre class="prettyprint linenums"># 导入copy模块
&gt;&gt;&gt; import copy
# 定义一个变量var1
&gt;&gt;&gt; var1 =
# 输出var1的内存地址
&gt;&gt;&gt; id(var1)

&gt;&gt;&gt; var2 = var1
# var2的内存地址和var1相同
&gt;&gt;&gt; id(var2)

# 浅拷贝
&gt;&gt;&gt; var3 = copy.copy(var1)
# var3的内存地址和var1相同
&gt;&gt;&gt; id(var3)

# 深拷贝
&gt;&gt;&gt; var4 = copy.deepcopy(var1)
# var4的内存地址和var1相同
&gt;&gt;&gt; id(var4)
</pre>
</div>
<h3>其他数据类型</h3>
<p>对于字典、元组、列表而言，进行赋值，深浅拷贝时，其内存地址的变化是不同的。</p>
<ul><li>创建一个字典<code>var1</code></li></ul>
<div>
<pre class="prettyprint linenums">var1 = {, ]}</pre>
</div>
<p><strong>1.赋值</strong></p>
<p>在python中对象的赋值其实就是对象的引用。当创建一个对象，把它赋值给另一个变量的时候，python并没有拷贝这个对象，只是拷贝了这个对象的引用而已。</p>
<div>
<pre class="prettyprint linenums">&gt;&gt;&gt; var1 = {, ]}
&gt;&gt;&gt; var2 = var1
&gt;&gt;&gt; id(var1)

&gt;&gt;&gt; id(var2)
1937003361288##var1, var2引用的同一个字典对象（内存地址一样），  所以该字典的任何改动，都会影响到var1，var2</pre>
</div>
<p>如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1197750/201801/1197750-20180104165350924-1341818306.png" /></p>
<p><strong>2.浅拷贝</strong></p>
<p>浅拷贝：&nbsp;浅拷贝值只拷贝一层，具有自己单独的内存地址。二层或其他层不拷贝，指向原有的内存地址。</p>
<div>
<pre class="prettyprint linenums"># 导入拷贝模块
&gt;&gt;&gt; import copy
&gt;&gt;&gt; var1 = {, ]}
# 使用浅拷贝的方式
&gt;&gt;&gt; var2 = copy.copy(var1)
# 两个变量的内存地址是不一样的
&gt;&gt;&gt; id(var1)

&gt;&gt;&gt; id(var2)

# 但是他们的元素内存地址是一样的
&gt;&gt;&gt; id(var1["k1"])

&gt;&gt;&gt; id(var2["k1"])
2084726207464

##浅copy只拷贝一层，也就是'k1' 'k2'以及所对应的值完全是两份数据，没有关联，修改了var1的'k1'，var2不会有影响。 对于'k3'的值来说，不属于第一次内容，所以修改会互相影响。</pre>
</div>
<p>如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1197750/201801/1197750-20180104165442831-1999744333.png" /></p>
<p><strong>3.深copy</strong></p>
<p>深拷贝，在内存中将所有的数据重新创建一份（排除最后一层，即：python内部对字符串和数字的优化）</p>
<div>
<pre class="prettyprint linenums"># 导入拷贝模块
&gt;&gt;&gt; import copy
&gt;&gt;&gt; var1 = {, ]}
# 使用深拷贝的方式把var1的内容拷贝给var2
&gt;&gt;&gt; var2 = copy.deepcopy(var1)
# var1和var2的内存地址是不相同的
&gt;&gt;&gt; id(var1)

&gt;&gt;&gt; id(var2)

# var1和var2的元素"k3"内存地址是不相同的
&gt;&gt;&gt; id(var1["k3"])

&gt;&gt;&gt; id(var2["k3"])
</pre>
<pre class="prettyprint linenums"># var1和var2的"k3"元素的内存地址是相同的
&gt;&gt;&gt; id(var1["k3"][1])
1706383265744
&gt;&gt;&gt; id(var2["k3"][1])
1706383265744</pre>
<pre class="prettyprint linenums">&nbsp;</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2017.cnblogs.com/blog/1197750/201801/1197750-20180104165517393-816710986.png" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqllevxq.html">关于pl&sol;sql数据库下拉中选项为空的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ownze9.html">Yii2框架与MongoDB拓展、Redis拓展的安装流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/96omldn9.html">C&num;反射Assembly 详细说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mgvdgq.html">React测试Mixin</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1oj1k8.html">target vs currentTarget&comma; clientWidth vs offsetWidth</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jddmx8.html">&lbrack;C&plus;&plus; Basic&rsqb; Const 用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg5lm78.html">MongoDb的&OpenCurlyDoubleQuote;not master and slaveok&equals;false&rdquo;错误及解决方法&comma;读写分离</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zokgdvq.html">HQL练习</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gep0208.html">hdu5514 非2的次幂容斥原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/96pke4v8.html">《阿里巴巴Android编码规范》阅读纪要&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/950l4gm8.html">jquery checkbox勾选&sol;取消勾选checked属性不生效问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjm4x38.html">关于jasperreport对应java打印机的解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj1gk49.html">解决JS中取URL地址中的参数中文乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1jx7w9.html">C语言博客作业05&mdash;&mdash;指针</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdkddz9.html">Sublime Text 3 插件</a>
		</li>
						<li><a href="https://www.batexi.com/a/93wjeznq.html">Codeforces1096G Lucky Tickets&lpar;NTT优化dp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy05xjq.html">&lbrack;leetcode&rsqb;64&period; Minimum Path Sum最小路径和</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnv04ok8.html">C&num;JSON与XML转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o47ox8.html">【Tomcat】Tomcat &plus; Memcached 实现session共享</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em7mzx9.html">UITableViewCell 取消分隔线</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8m2lln6q.html">2018ccpc湖南邀请赛后记</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllnnp1q.html">关于SSM的小感悟</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25m02wq.html">在Mac OS环境下安装MySQL服务</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllnkm6q.html">Unity-使用面向对象的思想</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnv2ynx8.html">Matlab2017A破解版安装详细图文教程&lpar;附破解补丁&rpar; 64位</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wdvnnq.html">Windows下的包管理工具-Scoop</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyr30d9.html">使用eclipse粗略统计代码代数【原】</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyy46lgq.html">HDU 1014&lpar;互质数 &ast;&ast;&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j1nx609.html">&lbrack;Windows&rsqb; &lbrack;VS&rsqb; &lbrack;C&rsqb; &lbrack;取得指针所指内存的十六进制形式字符串&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdox4j9.html">docker搭建lnmp环境</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
